Page MenuHomePhabricator

Implement an "Acting User" Herald condition
Closed, ResolvedPublic

Description

So it does not happen to me so I that's a bit spooky but at least one of our users is now getting email for self actions (despite having the option set) and promises they did not change the that recently.

Previous release was cut around 2015-03-12, latest upgrade (with the problem) was cut around 2015-04-08.

---------- Forwarded message ----------
From: "Ted Pearson" <psyduck@phabricator.clearspring.com>
Date: Fri, Apr 10, 2015 at 10:47 AM
Subject: [Maniphest] [Updated] T54467: DO IMPORTANT STUFF
To: "ted@addthis.com" <ted@addthis.com>

> ted added a project: squad-operations.
> ted added a comment.
> A COMMENT GOES HERE
> TASK DETAIL
>   http://phabricator.clearspring.local/T54467
> EMAIL PREFERENCES
>   http://phabricator.clearspring.local/settings/panel/emailpreferences/
> To: ted
> Cc: people

Event Timeline

cburroughs updated the task description. (Show Details)Apr 10 2015, 10:56 PM
cburroughs added a subscriber: cburroughs.
cburroughs created this task.
cburroughs raised the priority of this task from to Needs Triage.

Not sure what would be needed to debug in this case.

chad added a subscriber: chad.Apr 10 2015, 10:59 PM

Some or One?

Do they have "Send me an email" Herald actions? Herald is now stronger than notification preferences, after T7731.

You should be able to use bin/mail list-outbound + bin/mail show-outbound --id <id> to confirm this. T5791 will eventually build a self-serve web UI so users can learn these rules more easily.

If this is the cause, the Herald rule can likely be adjusted by adding a condition like:

[author][is not][alincoln]
chad added a project: Mail.Apr 11 2015, 5:58 AM

I've only confirmed one so far.

chad added a comment.Apr 16 2015, 9:26 PM

This is getting me know. I have self actions off but to email me when a new task comes in. The Herald rule now overpowers the setting.

Can you add a condition like:

[ Author ][ is not ] [ @chad ]

...to your rule?

chad added a comment.Apr 16 2015, 9:32 PM

I promise I'll learn how to use the product before I ask for a salary.

We should definitely write a "useful things you can do with Herald" or "Herald Recipe Book" document at some point, there's a bunch of stuff that isn't very obvious until you know what the answer is.

T7826 was a recent similar case where Herald is powerful enough to express something, it just isn't obvious how to build a ruleset.

cburroughs added a comment.EditedApr 17 2015, 2:16 PM

So I think Herald rules are the culprit on our end, but I can't figure out how to fix it:

Rule Description

When all of these conditions are met:
Projects include any of Platform Hardware

Take these actions every time this rule matches:
Send an email to squad-platform

There is no 'author usually does not like getting email for self actions' conditions.

"Object" and "Global" rules don't punch through settings, so that rule shouldn't be the culprit unless I screwed something up with the implementation.

The problematic rule would be a "Personal" rule owned by the user reporting the issue, which takes a "Send me an email" action.

(After T5791, there will be a link you can click to immediately identify the rule.)

cburroughs closed this task as Invalid.Apr 17 2015, 2:35 PM
cburroughs claimed this task.

Okay figured it out from the mail headers and transcript. The user did indeed have a personal rule.

epriestley renamed this task from Some users are getting emails for self actions after upgrade to Implement an "Acting User" Herald condition.Apr 24 2015, 9:13 PM
epriestley reopened this task as Open.

In the general case, we need to let you write this rule:

[Acting user][is not][chad]

...which is approximately a more general version of:

[Author][is not][chad]
epriestley removed cburroughs as the assignee of this task.
epriestley triaged this task as Normal priority.
eadler added a subscriber: eadler.Apr 29 2015, 11:08 PM
chad added subscribers: Mnkras, swisspol.

I think this is the correct merge, but maybe I am misreading this. Unmerge if wrong @epriestley.

These aren't quite the same. One is a new condition/field, which would let you write rules like this ("mail me about all zebra stuff, except if I took the action"):

If: 
[ Description ] [ contains ] [ "zebra" ]
[ Acting user ] [ is not ] [ chad ]
Take action:
[ Send an email to ] [ chad ]

One is a new action, which I assume is for writing rules like this (":

If:
[ Projects ][ do not include ][ X, Y, Z ]
Take action:
[ Add project ][ you-forgot-to-add-a-mandatory-project-you-must-add-x-y-or-z ]
[ Assign task to original author ]

If this is the intent, a better implementation might be "assign task to acting user", but regardless it's an action for Maniphest tasks rather than a condition for all transaction-edited objects, so it's not quite the same.

epriestley moved this task from Backlog to Next on the Herald board.Dec 9 2015, 1:37 PM
eadler added a project: Restricted Project.Jan 8 2016, 10:44 PM
eadler moved this task from Restricted Project Column to Restricted Project Column on the Restricted Project board.
eadler moved this task from Restricted Project Column to Restricted Project Column on the Restricted Project board.Feb 24 2016, 12:07 AM
eadler moved this task from Restricted Project Column to Restricted Project Column on the Restricted Project board.Jul 4 2016, 9:17 PM
epriestley moved this task from Backlog to v3 on the Mail board.Jul 16 2016, 1:51 PM
epriestley moved this task from Next to Far Future on the Herald board.Jan 26 2018, 5:52 PM
epriestley moved this task from v3 to Stamps/Failover on the Mail board.Feb 8 2018, 5:40 PM
This comment was removed by epriestley.